package checkboxsimpleapp;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Slider;
import javafx.scene.control.SliderBuilder;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleButton;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.paint.CycleMethod;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.shape.Rectangle;
import javafx.scene.shape.RectangleBuilder;
import javafx.stage.Stage;

/**
 *
 * @author alexandr_kirov
 */
public class Main3 extends Application{

    public static void main(String[] args) {
        launch(args);
    }

    @Override
    public void start(Stage stage) throws Exception {
        VBox vb = new VBox();
        CheckBox cb = new CheckBox("This is checkBox");
        cb.setMinWidth(40);
        cb.setPrefWidth(100);
        cb.setMaxWidth(150);
        cb.setGraphic(getNewRectangle());
        cb.setWrapText(true);

        TextField tf = new TextField("This is checkBox");
        Slider s = SliderBuilder.create().min(0).max(150).value(50).showTickLabels(true).showTickMarks(true).build();

        tf.textProperty().bindBidirectional(cb.textProperty());
        s.valueProperty().bindBidirectional(cb.graphicTextGapProperty());

        vb.getChildren().addAll(cb, tf, s);

        Scene scene = new Scene(vb, 300, 300);
        stage.setScene(scene);
        stage.show();
    }

    private Rectangle getNewRectangle(){
        Stop[] stops = new Stop[]{new Stop(0, Color.WHITE), new Stop(1, Color.BLACK)};
        LinearGradient lg = new LinearGradient(0, 0, 20, 20, false, CycleMethod.REPEAT, stops);
        return RectangleBuilder.create().width(20).height(20).fill(lg).build();
    }
}
